unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  Vcl.StdCtrls, math;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;

    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);

  private
    { Private declarations }
    Dist   : real;
    DelDis : real;
    x      : real;

    DistY   : real;
    Amp     : real;
    y,yini  : real;
    frec    : real;

    TT,t,dt : real;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  x      := 20;
  Dist   := 540;
  TT     := StrToFloat(Edit1.Text);

  DelDis := Dist /(TT*20);

  Timer1.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   t := 0.0;

   yini  := 100;
   Disty := 400;

   Amp := Disty-yini;

   TT    := StrToFloat(Edit1.Text);

   frec  := 2*pi/TT;

   dt    := Timer2.Interval/1000;

  Timer2.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  x := x + DelDis;

  Shape1.Left := ceil(x);
//  if (x>=Dist) then Timer1.Enabled := false;
  if (x>=Dist) or (x<= 20) then DelDis := - DelDis;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  y := yini + Amp*(1+sin(frec*t))/2;
  t := t + dt;

  Shape1.Top := ceil(y);

  Form1.Canvas.Ellipse(ceil(x-3)-5,ceil(y-3)-5,
                       ceil(x+3)-5,ceil(y+3)-5 );
end;

end.
